require(data.table)
source("cf_large_scale_parallel.R")

# input dados de compra da loja
input_set <- fread(input='in/collaborative_filtering_input.csv', header=TRUE, sep=';')

# tratamento para deixar todos em base 1,...,n
setkey(input_set, id_customer)
mapper.users <- unique(input_set[,"id_customer",with=FALSE])
mapper.users$user_id <- seq(1:nrow(mapper.users))
setkey(mapper.users, id_customer)
normalized_input_set <- mapper.users[input_set]

setkey(normalized_input_set, sku)
mapper.items <- unique(normalized_input_set[,"sku",with=FALSE])
mapper.items$item_id <- seq(1:nrow(mapper.items))
setkey(mapper.items, sku)
normalized_input_set <- mapper.items[normalized_input_set]

normalized_input_set <- normalized_input_set[,c("user_id", "item_id", "num_items"), with=FALSE]
normalized_input_set$num_items <- 1


# chamada para treinar a base: calcular as matrizes U e I
trainingCF(normalized_input_set, lambda = 0.03, nf = 100)

# input dos dados para realizar as recomendacoes
crm_base <- fread(input = "in/crm_base.csv", header = TRUE)
setkey(crm_base, id_customer)

setkey(mapper.users, id_customer)

crm_base <- mapper.users[crm_base]
crm_base <- crm_base[!is.na(user_id)]

crm_recommendations <- data.table()
# Recomendacoes de 20 items aos usuarios
for(i in 1:nrow(crm_base)) {
  recommendations <- getRecommendation(user_id=crm_base$user_id[i], num_recommendation=20)
  
  crm_recommendations <- rbindlist(list(crm_recommendations, data.table(cbind(id_customer=rep(crm_base$id_customer[i], times=length(recommendations)), recommendations, order=seq(from=1, to=length(recommendations))))))
}

setkey(mapper.items, item_id)
setkey(crm_recommendations, recommendations)

crm_recommendations <- mapper.items[crm_recommendations]
crm_recommendations <- crm_recommendations[,c("id_customer", "sku", "order"),with=FALSE]

write.table(x = crm_recommendations, file = "out/cf_recommendations.csv", sep = ";", row.names = FALSE, col.names = TRUE)
